% things to do:
% - forwards/backwards subset selection (run back on a large subset made by forwards)
% - fix fonts to match paper; spit out EPS files directly
% - documentation of Matlab code
% - better automatic way of picking the variable importance subset
% - bar graph showing which selection method was used, when there are many
% - another selection idea: exhaustive selection for subsets of size x,
% then FS from that point onward for every subset within some threshold of the best one


% PARAMETERS - most of what you might want to change in normal use is in
% the following section
% ========================================================================
% ========================================================================

% pipeline features
nAlgs = 1;
doVariableImportance = true;
doVariableImportance = false;
doQuadratic = true;
% doQuadratic = false;
cappedIncluded = true;
doPortfolio=false;
global doSubplots; doSubplots = false;
doBackTransform = false;
global useValidSet; useValidSet = false;
useValidSet = true;
global saveFigs; saveFigs = false;
global delta;  delta = 1e-6;


% LinearConditionNumberCutoff = 1e30; %1e12;
% QuadraticConditionNumberCutoff = 1e45; %1e25; %1e22;
% QuadraticConditionNumberCutoffDelta = 1e45; %1e25; %1e15;
% LinearCorrelationCutoff = 1;
% QuadraticCorrelationCutoff = 0.95;

%Data massaging parameters
linearR2Cutoff = 0.9999999; 
linearR2Cutoff = 0.99999; 
quadR2Cutoff = 0.99999;
doLinearPreprocessing = true;
doQuadPreprocessing = true;

% response variable transformations
global modelTransformations; modelTransformations = {'identity'; 'logistic'; 'log'; 'cuberoot'};
global transformation;  transformation = 3;  % this is one of the entries in the list one line above this line

% subset selection parameters
linSize = 30;
quadSize = 4000;
subsetSelectionMethods = {'forwardSelection'; 'backwardsSelection'; 'sequentialReplacement'; 'all'; 'exhaustive'};
linearSelectionMethod = 4;  % this is one of the entries in the list one line above this line
quadraticSelectionMethod = 1;
variableImportanceSelectionMethod = 1;

% variable importance parameters
variableImportanceSubsetSize = 0;  % if set to zero, variable importance uses smallest subset within 10% RMSE of full model
variableSelectionMaxSubsetSize = 80;
necessary_feature_threshold = .95;
vImpThreshold = 0.1; %5.5

%randomization test amount
doRandomizationTest = false;
randomAmt = 0.1;

% Parameters relating to input files
% ------------------------------------------------------------------------

%location = './nashportfolio/';
%currDataFile = 'nash-all';doLinearPreprocessing = false; doQuadPreprocessing=false;

%location = './satdata/';
%currDataFile = 'tmp';cappedIncluded=false;

location='./canewdata/';
%location='./cadata/';

%currDataFile = 'ca-1k-256-cplex';
%currDataFile = 'ca-varsize-cplex';
%currDataFile = 'ca-1k-144-cplex';
currDataFile = 'ca-2k-64-cplex';
%currDataFile = 'ca-1k-256-3solvers'; nAlgs = 3; doPortfolio=true; doVariableImportance = false;
%currDataFile = 'ca-varsize-2solvers'; nAlgs = 2; doPortfolio=true; doVariableImportance = false;
%currDataFile = 'ca-paths-1k-256';
%currDataFile = 'ca-1k-256-with-paths';
%currDataFile = 'ca-paths-varsize';
%currDataFile = 'ca-varsize-with-paths';

% =======================================================================
% Execution of the pipeline starts here
% =======================================================================

pipeline_exec