function [df res]=preprocessLoadFeatures(origdf, cutoff, inputFileName)
%function [df res]=preprocessFeatures(df, cutoff, inputFileName)
%
%Loads results of preprocessLoadFeatures and removes unnecessary features

error(nargchk(3,3,nargin));

df=origdf;

res=load(inputFileName);
res=res.res;


iter=1;

display('Preprocessing useless features...');
 
%condNumber = res(iter).condNumber;

r2=max(res(iter).R2);

while r2 > cutoff

    %find feature to be removed
    idx=res(iter).toRemove;
    
    display(sprintf('Removing feature: %s with r2 %f\n', res(iter).name, res(iter).R2(idx)));
    
    allfeats=1:size(df.traindata.features,2);
    df=projectDF(df, allfeats~=idx);
    
    iter=iter+1;
    
    if iter > length(res)
     display('Do not have information beyond current iteration. Stopping!');
     break;
    end
    
    %condNumber = res(iter).condNumber;
    r2=max(res(iter).R2);
end

display('Preprocessing finished!');

