function saveDF(trainfilename, testfilename, df, validfilename)
% function saveDF(trainfilename, testfilename)
%
% Write out a dataframe in CSV format

% open the file

error(nargchk(3,4,nargin));

writeHeader(trainfilename, df);
dlmwriteappend(trainfilename, [df.traindata.origResponse df.traindata.features], ',');

writeHeader(testfilename, df);
dlmwriteappend(testfilename, [df.testdata.origResponse df.testdata.features], ',');

if nargin==4
    writeHeader(validfilename, df);
    dlmwriteappend(validfilename, [df.validdata.origResponse df.validdata.features], ',');
end



%----------------------------------

function writeHeader(filename, df)

fid = fopen(filename ,'wb');
if fid == (-1), error(['Could not open file ' filename]); end

headers=[cellstr(df.algname) df.featurenames];

for str=headers(1:end-1)
    fprintf(fid, '%s,', char(str));
end
fprintf(fid, '%s\n', char(headers(end:end)));


fclose(fid);

