function newdf=squareDF(df)
%function newdf=squareDF(df)
%
%Constructs a new quadratic dataframe from the original one

newdf = df;

%code is similar to the one used in x2fx
[n m] = size(newdf.traindata.features);
first=repmat(1:m,m,1);
second=first';
t=first<=second;

newdf.traindata.features = zeros(n, m+m+m*(m-1)/2);
newdf.testdata.features = zeros(size(newdf.testdata.features,1), m+m+m*(m-1)/2);

newdf.traindata.features(:,1:m) = df.traindata.features;
newdf.testdata.features(:,1:m) = df.testdata.features;

newdf.traindata.features(:,m+1:end) = df.traindata.features(:,first(t)) .* df.traindata.features(:,second(t));
newdf.testdata.features(:,m+1:end) = df.testdata.features(:,first(t)) .* df.testdata.features(:,second(t));

if ~isempty(newdf.validdata)
    newdf.validdata.features = zeros(size(newdf.validdata.features,1), m+m+m*(m-1)/2);
    newdf.validdata.features(:,1:m) = df.validdata.features;
    newdf.validdata.features(:,m+1:end) = df.validdata.features(:,first(t)) .* df.validdata.features(:,second(t));
end

newnames = strcat(df.featurenames(first(t)),'.x.',df.featurenames(second(t)));
newdf.featurenames = [newdf.featurenames newnames];


